-- Beginning {{{
LootWindow = {
    nameCache ={},

    ITEM_QUALITIES_NAMES = {
        GetItemQualityColor(ITEM_QUALITY_NORMAL):Colorize(string.format("%s (%s)", "White" , GetString("SI_ITEMQUALITY", ITEM_QUALITY_NORMAL))),
        GetItemQualityColor(ITEM_QUALITY_MAGIC):Colorize(string.format("%s (%s)", "Green" , GetString("SI_ITEMQUALITY", ITEM_QUALITY_MAGIC))),
        GetItemQualityColor(ITEM_QUALITY_ARCANE):Colorize(string.format("%s (%s)", "Blue" , GetString("SI_ITEMQUALITY", ITEM_QUALITY_ARCANE))),
        GetItemQualityColor(ITEM_QUALITY_ARTIFACT):Colorize(string.format("%s (%s)", "Purple" , GetString("SI_ITEMQUALITY", ITEM_QUALITY_ARTIFACT))),
        GetItemQualityColor(ITEM_QUALITY_LEGENDARY):Colorize(string.format("%s (%s)", "Gold" , GetString("SI_ITEMQUALITY", ITEM_QUALITY_LEGENDARY))),
    },

    ITEM_QUALITIES = {
        ITEM_QUALITY_NORMAL,
        ITEM_QUALITY_MAGIC,
        ITEM_QUALITY_ARCANE,
        ITEM_QUALITY_ARTIFACT,
        ITEM_QUALITY_LEGENDARY
    },

    ARMOR_TRAIT_NAMES = {
        [ITEM_TRAIT_TYPE_ARMOR_DIVINES] = GetString("SI_ITEMTRAITTYPE", ITEM_TRAIT_TYPE_ARMOR_DIVINES),
        [ITEM_TRAIT_TYPE_ARMOR_IMPENETRABLE] = GetString("SI_ITEMTRAITTYPE", ITEM_TRAIT_TYPE_ARMOR_IMPENETRABLE),
        [ITEM_TRAIT_TYPE_ARMOR_INFUSED] = GetString("SI_ITEMTRAITTYPE", ITEM_TRAIT_TYPE_ARMOR_INFUSED),
        [ITEM_TRAIT_TYPE_ARMOR_NIRNHONED] = GetString("SI_ITEMTRAITTYPE", ITEM_TRAIT_TYPE_ARMOR_NIRNHONED),
        [ITEM_TRAIT_TYPE_ARMOR_PROSPEROUS] = GetString("SI_ITEMTRAITTYPE", ITEM_TRAIT_TYPE_ARMOR_PROSPEROUS),
        [ITEM_TRAIT_TYPE_ARMOR_REINFORCED] = GetString("SI_ITEMTRAITTYPE", ITEM_TRAIT_TYPE_ARMOR_REINFORCED),
        [ITEM_TRAIT_TYPE_ARMOR_STURDY] = GetString("SI_ITEMTRAITTYPE", ITEM_TRAIT_TYPE_ARMOR_STURDY),
        [ITEM_TRAIT_TYPE_ARMOR_TRAINING] = GetString("SI_ITEMTRAITTYPE", ITEM_TRAIT_TYPE_ARMOR_TRAINING),
        [ITEM_TRAIT_TYPE_ARMOR_WELL_FITTED] = GetString("SI_ITEMTRAITTYPE", ITEM_TRAIT_TYPE_ARMOR_WELL_FITTED),
        [ITEM_TRAIT_TYPE_ARMOR_INTRICATE] = GetString("SI_ITEMTRAITTYPE", ITEM_TRAIT_TYPE_ARMOR_INTRICATE),
        [ITEM_TRAIT_TYPE_ARMOR_ORNATE] = GetString("SI_ITEMTRAITTYPE", ITEM_TRAIT_TYPE_ARMOR_ORNATE),
    },

    ARMOR_TRAITS = {
        ITEM_TRAIT_TYPE_ARMOR_DIVINES,
        ITEM_TRAIT_TYPE_ARMOR_IMPENETRABLE,
        ITEM_TRAIT_TYPE_ARMOR_INFUSED,
        ITEM_TRAIT_TYPE_ARMOR_NIRNHONED,
        ITEM_TRAIT_TYPE_ARMOR_PROSPEROUS,
        ITEM_TRAIT_TYPE_ARMOR_REINFORCED,
        ITEM_TRAIT_TYPE_ARMOR_STURDY,
        ITEM_TRAIT_TYPE_ARMOR_TRAINING,
        ITEM_TRAIT_TYPE_ARMOR_WELL_FITTED,
        ITEM_TRAIT_TYPE_ARMOR_INTRICATE,
        ITEM_TRAIT_TYPE_ARMOR_ORNATE,
    },

    FADE_ANIMATION_DELAY = 3000,
    FADE_ANIMATION_DURATION = 500,

    version = 1.3,

    headerFontSize = 20,
    name = "LootWindow",
    displayName = "|caaaaffLoot Window|r",
    hide = false,

    defaults = {
        verbose = false,
        save = {},
        chat = false,
        fadeOut = true,
        locked = false,
        minMax = false,
        group = true,
        showHeader = true,
        showGold = false,
        self = true,
        opacity = 40,
        you = "You",
        show = true,
        width = 500,
        height = 249,
        fontSize = 15,

        jewelColor = ITEM_QUALITY_ARCANE,
        armorColor = ITEM_QUALITY_MAGIC,
        weaponColor = ITEM_QUALITY_MAGIC,

        armorTraits = { -- {{{
            [EQUIP_TYPE_CHEST] = {
                [ITEM_TRAIT_TYPE_ARMOR_DIVINES] = true,
                [ITEM_TRAIT_TYPE_ARMOR_IMPENETRABLE] = false,
                [ITEM_TRAIT_TYPE_ARMOR_INFUSED] = true,

                [ITEM_TRAIT_TYPE_ARMOR_NIRNHONED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_PROSPEROUS] = false,
                [ITEM_TRAIT_TYPE_ARMOR_REINFORCED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_STURDY] = false,
                [ITEM_TRAIT_TYPE_ARMOR_TRAINING] = false,
                [ITEM_TRAIT_TYPE_ARMOR_WELL_FITTED] = false,

                [ITEM_TRAIT_TYPE_ARMOR_INTRICATE] = false,
                [ITEM_TRAIT_TYPE_ARMOR_ORNATE] = false,
            },

            [EQUIP_TYPE_HEAD] = {
                [ITEM_TRAIT_TYPE_ARMOR_DIVINES] = true,
                [ITEM_TRAIT_TYPE_ARMOR_IMPENETRABLE] = false,
                [ITEM_TRAIT_TYPE_ARMOR_INFUSED] = true,

                [ITEM_TRAIT_TYPE_ARMOR_NIRNHONED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_PROSPEROUS] = false,
                [ITEM_TRAIT_TYPE_ARMOR_REINFORCED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_STURDY] = false,
                [ITEM_TRAIT_TYPE_ARMOR_TRAINING] = false,
                [ITEM_TRAIT_TYPE_ARMOR_WELL_FITTED] = false,

                [ITEM_TRAIT_TYPE_ARMOR_INTRICATE] = false,
                [ITEM_TRAIT_TYPE_ARMOR_ORNATE] = false,
            },

            [EQUIP_TYPE_LEGS] = {
                [ITEM_TRAIT_TYPE_ARMOR_DIVINES] = true,
                [ITEM_TRAIT_TYPE_ARMOR_IMPENETRABLE] = false,
                [ITEM_TRAIT_TYPE_ARMOR_INFUSED] = true,

                [ITEM_TRAIT_TYPE_ARMOR_NIRNHONED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_PROSPEROUS] = false,
                [ITEM_TRAIT_TYPE_ARMOR_REINFORCED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_STURDY] = false,
                [ITEM_TRAIT_TYPE_ARMOR_TRAINING] = false,
                [ITEM_TRAIT_TYPE_ARMOR_WELL_FITTED] = false,

                [ITEM_TRAIT_TYPE_ARMOR_INTRICATE] = false,
                [ITEM_TRAIT_TYPE_ARMOR_ORNATE] = false,
            },


            [EQUIP_TYPE_FEET] = {
                [ITEM_TRAIT_TYPE_ARMOR_DIVINES] = true,
                [ITEM_TRAIT_TYPE_ARMOR_IMPENETRABLE] = false,

                [ITEM_TRAIT_TYPE_ARMOR_INFUSED] = false,

                [ITEM_TRAIT_TYPE_ARMOR_NIRNHONED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_PROSPEROUS] = false,
                [ITEM_TRAIT_TYPE_ARMOR_REINFORCED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_STURDY] = false,
                [ITEM_TRAIT_TYPE_ARMOR_TRAINING] = false,
                [ITEM_TRAIT_TYPE_ARMOR_WELL_FITTED] = false,

                [ITEM_TRAIT_TYPE_ARMOR_INTRICATE] = false,
                [ITEM_TRAIT_TYPE_ARMOR_ORNATE] = false,
            },

            [EQUIP_TYPE_HAND] = {
                [ITEM_TRAIT_TYPE_ARMOR_DIVINES] = true,
                [ITEM_TRAIT_TYPE_ARMOR_IMPENETRABLE] = false,

                [ITEM_TRAIT_TYPE_ARMOR_INFUSED] = false,

                [ITEM_TRAIT_TYPE_ARMOR_NIRNHONED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_PROSPEROUS] = false,
                [ITEM_TRAIT_TYPE_ARMOR_REINFORCED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_STURDY] = false,
                [ITEM_TRAIT_TYPE_ARMOR_TRAINING] = false,
                [ITEM_TRAIT_TYPE_ARMOR_WELL_FITTED] = false,

                [ITEM_TRAIT_TYPE_ARMOR_INTRICATE] = false,
                [ITEM_TRAIT_TYPE_ARMOR_ORNATE] = false,
            },

            [EQUIP_TYPE_SHOULDERS] = {
                [ITEM_TRAIT_TYPE_ARMOR_DIVINES] = true,
                [ITEM_TRAIT_TYPE_ARMOR_IMPENETRABLE] = false,

                [ITEM_TRAIT_TYPE_ARMOR_INFUSED] = false,

                [ITEM_TRAIT_TYPE_ARMOR_NIRNHONED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_PROSPEROUS] = false,
                [ITEM_TRAIT_TYPE_ARMOR_REINFORCED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_STURDY] = false,
                [ITEM_TRAIT_TYPE_ARMOR_TRAINING] = false,
                [ITEM_TRAIT_TYPE_ARMOR_WELL_FITTED] = false,

                [ITEM_TRAIT_TYPE_ARMOR_INTRICATE] = false,
                [ITEM_TRAIT_TYPE_ARMOR_ORNATE] = false,
            },

            [EQUIP_TYPE_WAIST]= {
                [ITEM_TRAIT_TYPE_ARMOR_DIVINES] = true,
                [ITEM_TRAIT_TYPE_ARMOR_IMPENETRABLE] = false,

                [ITEM_TRAIT_TYPE_ARMOR_INFUSED] = false,

                [ITEM_TRAIT_TYPE_ARMOR_NIRNHONED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_PROSPEROUS] = false,
                [ITEM_TRAIT_TYPE_ARMOR_REINFORCED] = false,
                [ITEM_TRAIT_TYPE_ARMOR_STURDY] = false,
                [ITEM_TRAIT_TYPE_ARMOR_TRAINING] = false,
                [ITEM_TRAIT_TYPE_ARMOR_WELL_FITTED] = false,

                [ITEM_TRAIT_TYPE_ARMOR_INTRICATE] = false,
                [ITEM_TRAIT_TYPE_ARMOR_ORNATE] = false,
            }
        }, -- }}}

        ui =
        {
            ["point"] = 6,
            ["offsetX"] = 8.4955749512,
            ["relPoint"] = 6,
            ["offsetY"] = -332.9210815430,
        },
    },

} -- }}}

-- UI {{{
function LootWindow:AddMessage(msg)
    LootWindow.Fade(false)

    if LootWindow.sv.chat then
        d ( msg )
    end

    LootWindowMainScrollBar:SetHidden(false)
    LootWindowMainScrollBarUp:SetHidden(true)
    LootWindowMainScrollBarDown:SetHidden(true)

    LootWindowBuffer:AddMessage(msg)

    local orig = LootWindowBuffer:GetScrollPosition()
    LootWindowBuffer:SetScrollPosition(10000)

    LootWindowMainScrollBar:SetMinMax(0, LootWindowBuffer:GetScrollPosition())
    LootWindowMainScrollBar:SetValueStep(1)

    if orig == 0 then
        LootWindowMainScrollBar:SetValue(LootWindowBuffer:GetScrollPosition())
        LootWindowBuffer:SetScrollPosition(0)
    else
        LootWindowBuffer:SetScrollPosition(orig)
    end

    LootWindow.Fade(true)
end

function LootWindow:SetFontSize()
    local face = "$(CHAT_FONT)"
    local shadowStyle = "soft-shadow-thick"
    if LootWindow.sv.fontSize <= 14 then
        shadowStyle = "soft-shadow-thin"
    end

    LootWindowBuffer:SetFont(("%s|%s|%s"):format(face, LootWindow.sv.fontSize, shadowStyle))
end

function toggleLootWindow()
    LootWindow.sv.show = LootWindowBuffer:IsHidden()
    LootWindowBuffer:SetHidden(not LootWindowBuffer:IsHidden())
end

function LootWindow:UpdateDimensions()
    if LootWindow.sv.minMax and LootWindow.sv.showHeader then
        LootWindowMain:ClearAnchors()
        LootWindowMain:SetAnchor(LootWindow.sv.ui.point, GuiRoot, LootWindow.sv.ui.relPoint, LootWindow.sv.ui.offsetX, LootWindow.sv.ui.offsetY - LootWindow.sv.height + 30)

        LootWindowMain:SetDimensions(LootWindow.sv.width, 30)
    else
        LootWindowMain:ClearAnchors()
        LootWindowMain:SetAnchor(LootWindow.sv.ui.point, GuiRoot, LootWindow.sv.ui.relPoint, LootWindow.sv.ui.offsetX, LootWindow.sv.ui.offsetY)
        LootWindowBuffer:ClearAnchors()
        LootWindowBuffer:SetAnchor(TOPLEFT, LootWindowMain, TOPLEFT, 0, 30)

        LootWindowMain:SetDimensions(LootWindow.sv.width, LootWindow.sv.height)
        LootWindowBuffer:SetDimensions(LootWindow.sv.width, LootWindow.sv.height - 30)
    end
end

function LootWindow:UpdateHeaderText()
    if LootWindow.sv.showHeader then
        LootWindowMain:SetText(LootWindow.displayName ..
        "      |t"..LootWindow.headerFontSize..":"..LootWindow.headerFontSize..":EsoUI/Art/Inventory/Gamepad/gp_inventory_icon_currencies.dds|t" ..
        zo_strformat(SI_NUMBER_FORMAT, ZO_Currency_FormatKeyboard(CURT_MONEY, GetCurrencyAmount(CURT_MONEY, CURRENCY_LOCATION_CHARACTER), ZO_CURRENCY_FORMAT_PARENTHETICAL_AMOUNT)) ..
        "      |t"..LootWindow.headerFontSize..":"..LootWindow.headerFontSize..":EsoUI/Art/Inventory/Gamepad/gp_inventory_icon_all.dds|t" .. GetNumBagUsedSlots(BAG_BACKPACK) .. " / " .. GetBagSize(BAG_BACKPACK) .. "     ")
    else
        LootWindowMain:SetText("")
    end
end

function LootWindow:Clear()
    LootWindowBuffer:Clear()
end

function LootWindow:FixLock()
    if LootWindow.sv.locked then
        LootWindowMain:SetResizeHandleSize()
        LootWindowMain:SetMovable()
        LootWindowMainLock.data = { tooltipText = "Unlock"}
        LootWindowMainLock:SetNormalTexture("EsoUI/Art/tutorial/gamepad/gp_icon_unlocked32.dds")
        LootWindowMainLock:SetMouseOverTexture("EsoUI/Art/tutorial/gamepad/gp_icon_unlocked32.dds")
    else
        if not LootWindow.sv.minMax then
            LootWindowMain:SetResizeHandleSize(8)
        end

        LootWindowMain:SetMovable(true)
        LootWindowMainLock.data = { tooltipText = "Lock"}
        LootWindowMainLock:SetNormalTexture("EsoUI/Art/tutorial/gamepad/gp_icon_locked32.dds")
        LootWindowMainLock:SetMouseOverTexture("EsoUI/Art/tutorial/gamepad/gp_icon_locked32.dds")
    end
end

function LootWindow:FixMinMax()
    if LootWindow.sv.minMax then
        LootWindowMainMinMax.data = { tooltipText = "Header and Window"}
        LootWindowMainMinMax:SetNormalTexture("EsoUI/Art/chatwindow/maximize_up.dds")
        LootWindowMainMinMax:SetMouseOverTexture("EsoUI/Art/chatwindow/maximize_up.dds")
        LootWindowBuffer:SetHidden(true)

        LootWindowMain:SetResizeHandleSize()
    else
        LootWindowMainMinMax.data = { tooltipText = "Only Header"}
        LootWindowMainMinMax:SetNormalTexture("EsoUI/Art/chatwindow/minimize_up.dds")
        LootWindowMainMinMax:SetMouseOverTexture("EsoUI/Art/chatwindow/minimize_up.dds")
        LootWindowBuffer:SetHidden(false)

        if not LootWindow.sv.locked then
            LootWindowMain:SetResizeHandleSize(8)
        end
    end

    LootWindow:UpdateDimensions(true)
end

function LootWindow:Fade(out)
    if not LootWindow.sv.fadeOut or not LootWindow.sv.show then
        return
    end

    -- lazyload animation
    if not LootWindow.fadeAnim then
        LootWindow.fadeAnim = ZO_AlphaAnimation:New(LootWindowMain)
        LootWindow.fadeAnim:SetMinMaxAlpha(0, LootWindow.sv.opacity)
    end

    if out then
        LootWindow.fadeAnim:FadeOut(LootWindow.FADE_ANIMATION_DELAY, LootWindow.FADE_ANIMATION_DURATION)
    else
        LootWindow.fadeAnim:FadeIn(0, LootWindow.FADE_ANIMATION_DURATION)
    end
end

-- }}}

-- Load Addon {{{
EVENT_MANAGER:RegisterForEvent(LootWindow.name, EVENT_ADD_ON_LOADED, function ( eventCode, addonName )
    if (addonName ~= LootWindow.name) then return end

    EVENT_MANAGER:UnregisterForEvent(LootWindow.name, EVENT_ADD_ON_LOADED)

    LootWindow.sv = ZO_SavedVars:NewAccountWide("LootWindowSavedVariables", 1, nil, LootWindow.defaults, nil, "$InstallationWide")

    LootWindowMain:SetHandler("OnMoveStop", function (self)
        local valid, point, _, relPoint, offsetX, offsetY = self:GetAnchor(0)
        if valid then
            LootWindow.sv.ui.point = point
            LootWindow.sv.ui.relPoint = relPoint
            LootWindow.sv.ui.offsetX = offsetX
            LootWindow.sv.ui.offsetY = offsetY
        end
    end)

    LootWindowMain:ClearAnchors()
    LootWindowMain:SetAnchor(LootWindow.sv.ui.point, GuiRoot, LootWindow.sv.ui.relPoint, LootWindow.sv.ui.offsetX, LootWindow.sv.ui.offsetY)

    LootWindowBuffer:ClearAnchors()
    LootWindowBuffer:SetAnchor(TOPLEFT, LootWindowMain, TOPLEFT, 0, 30)

    LootWindow:UpdateDimensions()
    LootWindow:UpdateHeaderText()
    LootWindow:SetFontSize()

    LootWindowMain:SetHidden(not LootWindow.sv.show)
    LootWindowMainBG:SetAlpha(LootWindow.sv.opacity / 100.0)

    LootWindowMain:SetHandler("OnResizeStop", function(control)
        local width, height = control:GetDimensions()
        LootWindow.sv.width = width
        LootWindow.sv.height = height
        LootWindow:UpdateDimensions()
    end)

    LootWindowMainMinMax:SetHandler("OnClicked", function()
        LootWindow.sv.minMax = not LootWindow.sv.minMax
        LootWindow:FixMinMax()
    end)

    LootWindowMainLock:SetHandler("OnClicked", function()
        LootWindow.sv.locked = not LootWindow.sv.locked
        LootWindow:FixLock()
    end)

    LootWindowMainClear:SetHandler("OnClicked", function()
        LootWindow:Clear()
    end)

    LootWindowMainMinMax:SetHidden(not LootWindow.sv.showHeader)
    LootWindowMainMinMax:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
    LootWindowMainMinMax:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)

    LootWindowMainLock:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
    LootWindowMainLock:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)

    LootWindowMainClear:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
    LootWindowMainClear:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)
    LootWindowMainClear.data = { tooltipText = "Clear Loot Windows List"}
    LootWindowMainClear:SetNormalTexture("LootWindow/clear.dds")
    LootWindowMainClear:SetMouseOverTexture("LootWindow/clear.dds")

    LootWindow:FixLock()
    LootWindow:FixMinMax()
    LootWindow:Fade(true)

    LootWindow:CreateSettingsWindow()


    local scenes= {"hud", "hudui" }

    for _, scene in ipairs(scenes) do
        local sceneObj = SCENE_MANAGER:GetScene(scene)

        sceneObj:RegisterCallback("StateChange", function(oldState, newState)
            -- d ( scene .. " :: " .. tostring(oldState) .. " -› " .. tostring(newState) )
            LootWindow.hide = not ( newState and ( newState == "showing" or newState == "shown" ) )

            if LootWindow.hide then LootWindow:Fade(true) else
            end
        end)
    end

    LootWindow:RegisterEvents()
end)
-- }}}

-- Events {{{
function LootWindow:RegisterEvents()
    -- {{{ Loot event
    EVENT_MANAGER:RegisterForEvent(LootWindow.name, EVENT_LOOT_RECEIVED, function ( eventCode, receivedBy, itemName, quantity, itemSound, lootType, self, isPickpocketLoot, questItemIcon, itemId )
        local bindType = GetItemLinkBindType(itemName)

        if ( (lootType ~= LOOT_TYPE_ITEM and lootType ~= LOOT_TYPE_COLLECTIBLE) or
            (self and not LootWindow.sv.self) or
            (not self and not LootWindow.sv.group and ( bindType == BIND_TYPE_NONE or bindType == BIND_TYPE_ON_EQUIP))) then
            return
        end

        local itemCat = GetItemLinkTraitCategory(itemName)
        local itemQuip = GetItemLinkEquipType(itemName)

        local itemType, specializedItemType = GetItemLinkItemType(itemName)
        local itemQuality = GetItemLinkQuality(itemName)
        local hasSet, setName, numBonuses, numEquipped, maxEquipped, setId = GetItemLinkSetInfo(itemName)

        local itemIsKeyFragment = (itemType == ITEMTYPE_TROPHY) and (specializedItemType == SPECIALIZED_ITEMTYPE_TROPHY_KEY_FRAGMENT)
        local itemTrait = GetItemLinkTraitInfo(itemName)

        -- d ( string.format("Cat : %d Quality : %d armor : %d jewelColor %d weaponColor %d", itemCat, itemQuality, LootWindow.sv.armorColor, LootWindow.sv.jewelColor, LootWindow.sv.weaponColor ) )
        -- d ( string.format("Quip : %d ", itemQuip) )

        if (LootWindow.sv.verbose or
            (((itemCat == ITEM_TRAIT_TYPE_CATEGORY_ARMOR and itemQuality >= LootWindow.sv.armorColor) or
             (itemCat == ITEM_TRAIT_TYPE_CATEGORY_JEWELRY and itemQuality >= LootWindow.sv.jewelColor) or
             (itemCat == ITEM_TRAIT_TYPE_CATEGORY_WEAPON and itemQuality >= LootWindow.sv.weaponColor)) and
            (LootWindow.sv.armorTraits[itemQuip] == nil or LootWindow.sv.armorTraits[itemQuip][itemTrait]))) then

            local formattedRecipient
            local formattedQuantity = ""
            local formattedTrait = ""

            if (self) then
                formattedRecipient = LootWindow.sv.you
            else
                local accountName = LootWindow.nameCache[receivedBy]

                if (not accountName) then
                    for i = 1, GetGroupSize() do
                        local unitTag = GetGroupUnitTagByIndex(i)
                        if (GetRawUnitName(unitTag) == receivedBy) then
                            accountName = GetUnitDisplayName(unitTag)
                            LootWindow.nameCache[receivedBy] = accountName
                            break
                        end
                    end
                end

                local charName = LocalizeString("<<1>>", receivedBy)

                formattedRecipient = string.format("|H1:character:%s|h[%s%s]|h", receivedBy, charName, accountName)
            end

            if (quantity > 1) then
                formattedQuantity = string.format("|cFFFFFF x %d|r", quantity)
            end

            if (itemTrait ~= ITEM_TRAIT_TYPE_NONE and itemType ~= ITEMTYPE_ARMOR_TRAIT and itemType ~= ITEMTYPE_WEAPON_TRAIT) then
                formattedTrait = string.format(" |cFFFFFF(%s)|r", GetString("SI_ITEMTRAITTYPE", itemTrait))
            end

            local icon = GetItemLinkInfo(itemName)
            local msg = string.format( "|t"..LootWindow.sv.fontSize..":"..LootWindow.sv.fontSize..":%s|t %s%s%s — |c%06X%s|r",
                icon,
                itemName:gsub("^|H0", "|H1", 1),
                formattedQuantity,
                formattedTrait,
                HashString(formattedRecipient) % 0x1000000,
                formattedRecipient
            )

            LootWindow:AddMessage ( msg )
        end
    end)

    -- }}}

    -- {{{ other events
    EVENT_MANAGER:RegisterForEvent(LootWindow.name, EVENT_INVENTORY_SINGLE_SLOT_UPDATE, function(eventCode, bagId, slotId, isNewItem, itemSoundCategory, inventoryUpdateReason, stackCountChange)
        LootWindow:UpdateHeaderText()
    end)

    EVENT_MANAGER:RegisterForEvent(LootWindow.name, EVENT_MONEY_UPDATE , function (eventCode, newMoney, oldMoney, reason)
        LootWindow:UpdateHeaderText()

        if not LootWindow.sv.showGold then return end

        local diff = newMoney - oldMoney
        local diffSym = ""

        local color = "ffaaaa"
        if diff > 0 then
            color = "aaffaa"
            diffSym = "+"
        elseif diff == 0 then
            return
        end

        LootWindow:AddMessage("|t"..LootWindow.sv.fontSize..":"..LootWindow.sv.fontSize..":esoui/art/bank/bank_tabicon_gold_up.dds|t |c".. color .. diffSym .. diff .. "|r")
    end)

    -- }}}
end
-- }}}

-- Settings{{{
function LootWindow:CreateSettingsWindow()
    local LAM = LibAddonMenu2

    local settingsWindowData = {
        type = "panel",
        name = LootWindow.displayName,
        author = "|caaaaffJodynn|r",
        version = LootWindow.version .. "",
        registerForRefresh = true,
        registerForDefaults = true,
        slashCommand = "/lootwindow",
    }

    local settingsOptionsData = {
        -- Basic {{{
        {
            type = "submenu",
            name = "Basic Settings",
            controls = {
                {
                    type = "checkbox",
                    name = "Show Window",
                    default = LootWindow.sv.show,
                    getFunc = function() return LootWindow.sv.show end,
                    setFunc = function(newValue)
                        LootWindow.sv.show = newValue

                        LootWindowBuffer:SetHidden(not newValue)
                    end,
                },

                {
                    type = "checkbox",
                    name = "Show Header",
                    tooltip = "LootWindow - Money - Items/BagSpace",
                    default = LootWindow.sv.showHeader,
                    getFunc = function() return LootWindow.sv.showHeader end,
                    setFunc = function(newValue)
                        LootWindow.sv.showHeader = newValue
                        LootWindowMainMinMax:SetHidden(not newValue)
                        LootWindow:UpdateHeaderText()
                    end,
                },

                {
                    type = "checkbox",
                    name = "Log in Chat",
                    tooltip = "Log in the chat window",
                    default = LootWindow.sv.chat,
                    getFunc = function() return LootWindow.sv.chat end,
                    setFunc = function(newValue)
                        LootWindow.sv.chat = newValue
                    end,
                },

                {
                    type = "checkbox",
                    name = "Verbose",
                    tooltip = "Log everything ignoring filters other than Collectibles and items that can't be traded.",
                    default = LootWindow.sv.verbose,
                    getFunc = function() return LootWindow.sv.verbose end,
                    setFunc = function(newValue)
                        LootWindow.sv.verbose = newValue
                    end,
                },

                {
                    type = "checkbox",
                    name = "Show Gold",
                    tooltip = "Log gold differences",
                    default = LootWindow.sv.showGold,
                    getFunc = function() return LootWindow.sv.showGold end,
                    setFunc = function(newValue) LootWindow.sv.showGold = newValue end,
                },

                {
                    type = "checkbox",
                    name = "Self Logging",
                    tooltip = "Show your own items you gain",
                    default = LootWindow.sv.self,
                    getFunc = function() return LootWindow.sv.self end,
                    setFunc = function(newValue) LootWindow.sv.self = newValue end,
                },

                {
                    type = "checkbox",
                    name = "Group Logging",
                    tooltip = "Show your groups items they gain",
                    default = LootWindow.sv.group,
                    getFunc = function() return LootWindow.sv.group end,
                    setFunc = function(newValue) LootWindow.sv.group = newValue end,
                },

                {
                    type = "checkbox",
                    name = "Fade out",
                    tooltip = "Automatically fade out, similar to the chat window",
                    default = LootWindow.sv.fadeOut,
                    getFunc = function() return LootWindow.sv.fadeOut end,
                    setFunc = function(newValue) LootWindow.sv.fadeOut = newValue end,
                },

                {
                    type = "slider",
                    name = "Opacity",
                    min = 0,
                    max = 100,
                    step = 1,
                    default = LootWindow.sv.opacity,
                    getFunc = function() return LootWindow.sv.opacity end,
                    setFunc = function(newValue)
                        LootWindowMainBG:SetAlpha(newValue / 100.0)
                        if LootWindow.fadeAnim then
                            LootWindow.fadeAnim:SetMinMaxAlpha(0, LootWindow.sv.opacity)
                        end
                        LootWindow.sv.opacity = newValue
                    end,
                },

                {
                    type = "slider",
                    name = "Font Size",
                    min = 10,
                    max = 50,
                    step = 1,
                    default = LootWindow.sv.fontSize,
                    getFunc = function() return LootWindow.sv.fontSize end,
                    setFunc = function(newValue)
                        LootWindow.sv.fontSize = newValue
                        LootWindow:SetFontSize()
                    end,
                },

                {
                    type = "editbox",
                    name = "Your Identifier",
                    tooltip = "What you would like the Addon to call you when you loot something.",
                    default = LootWindow.sv.you,
                    getFunc = function() return LootWindow.sv.you end,
                    setFunc = function(newValue)
                        LootWindow.sv.you = newValue
                    end,
                },

            }
        }, -- }}}

        -- Loot Filter {{{
        {
            type = "submenu",
            name = "Loot Filter Settings",
            tooltip = "Filter your loot how you want to see it. Note, Collectibles are already filtered, and it will also already filter your groupmates loot that can not be traded.",
            controls = {
                {
                    type = "dropdown",
                    name = "Jewelery Min. Quality",
                    tooltip = "Then lowest level of quality you'll accept, meaning it has to be AT LEAST green, or blue, or whatever you pick.",
                    default = LootWindow.sv.jewelColor,
                    choices = LootWindow.ITEM_QUALITIES_NAMES,
                    choicesValues = LootWindow.ITEM_QUALITIES,
                    getFunc = function() return LootWindow.sv.jewelColor end,
                    setFunc = function(newValue) LootWindow.sv.jewelColor = newValue end,
                },

                {
                    type = "dropdown",
                    name = "Armor Min. Quality",
                    tooltip = "Then lowest level of quality you'll accept, meaning it has to be AT LEAST green, or blue, or whatever you pick.",
                    default = LootWindow.sv.armorColor,
                    choices = LootWindow.ITEM_QUALITIES_NAMES,
                    choicesValues = LootWindow.ITEM_QUALITIES,
                    getFunc = function() return LootWindow.sv.armorColor end,
                    setFunc = function(newValue) LootWindow.sv.armorColor = newValue end,
                },

                {
                    type = "dropdown",
                    name = "Weapon Min. Quality",
                    tooltip = "Then lowest level of quality you'll accept, meaning it has to be AT LEAST green, or blue, or whatever you pick.",
                    default = LootWindow.sv.weaponColor,
                    choices = LootWindow.ITEM_QUALITIES_NAMES,
                    choicesValues = LootWindow.ITEM_QUALITIES,
                    getFunc = function() return LootWindow.sv.weaponColor end,
                    setFunc = function(newValue) LootWindow.sv.weaponColor = newValue end,
                },

                {
                    type = "divider",
                },

                {
                    type = "header",
                    name = "Armor Traits"
                },

                -- {{{ Chest
                {
                    type = "submenu",
                    name = "Chest",
                    controls = {
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[1]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[1]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[1]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[1]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[2]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[2]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[2]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[2]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[3]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[3]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[3]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[3]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[4]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[4]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[4]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[4]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[5]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[5]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[5]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[5]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[6]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[6]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[6]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[6]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[7]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[7]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[7]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[7]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[8]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[8]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[8]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[8]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[9]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[9]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[9]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[9]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[10]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[10]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[10]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[10]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[11]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[11]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[11]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_CHEST][LootWindow.ARMOR_TRAITS[11]] = newValue
                            end,
                        },
                    },
                }, -- }}}
                -- {{{ Head
                {
                    type = "submenu",
                    name = "Head",
                    controls = {
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[1]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[1]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[1]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[1]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[2]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[2]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[2]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[2]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[3]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[3]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[3]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[3]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[4]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[4]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[4]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[4]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[5]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[5]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[5]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[5]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[6]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[6]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[6]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[6]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[7]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[7]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[7]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[7]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[8]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[8]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[8]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[8]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[9]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[9]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[9]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[9]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[10]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[10]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[10]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[10]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[11]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[11]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[11]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HEAD][LootWindow.ARMOR_TRAITS[11]] = newValue
                            end,
                        },
                    },
                }, -- }}}
                -- {{{ Legs
                {
                    type = "submenu",
                    name = "Legs",
                    controls = {
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[1]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[1]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[1]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[1]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[2]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[2]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[2]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[2]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[3]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[3]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[3]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[3]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[4]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[4]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[4]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[4]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[5]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[5]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[5]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[5]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[6]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[6]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[6]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[6]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[7]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[7]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[7]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[7]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[8]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[8]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[8]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[8]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[9]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[9]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[9]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[9]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[10]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[10]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[10]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[10]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[11]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[11]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[11]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_LEGS][LootWindow.ARMOR_TRAITS[11]] = newValue
                            end,
                        },
                    },
                }, -- }}}
                 -- {{{ Feet
                 {
                    type = "submenu",
                    name = "Feet",
                    controls = {
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[1]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[1]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[1]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[1]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[2]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[2]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[2]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[2]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[3]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[3]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[3]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[3]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[4]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[4]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[4]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[4]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[5]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[5]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[5]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[5]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[6]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[6]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[6]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[6]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[7]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[7]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[7]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[7]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[8]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[8]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[8]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[8]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[9]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[9]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[9]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[9]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[10]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[10]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[10]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[10]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[11]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[11]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[11]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_FEET][LootWindow.ARMOR_TRAITS[11]] = newValue
                            end,
                        },
                    },
                }, -- }}}
                -- {{{ Hands
                {
                    type = "submenu",
                    name = "Hands",
                    controls = {
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[1]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[1]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[1]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[1]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[2]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[2]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[2]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[2]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[3]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[3]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[3]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[3]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[4]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[4]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[4]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[4]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[5]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[5]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[5]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[5]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[6]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[6]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[6]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[6]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[7]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[7]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[7]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[7]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[8]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[8]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[8]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[8]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[9]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[9]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[9]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[9]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[10]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[10]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[10]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[10]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[11]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[11]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[11]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_HAND][LootWindow.ARMOR_TRAITS[11]] = newValue
                            end,
                        },
                    },
                }, -- }}}
                -- {{{ Shoulders
                {
                    type = "submenu",
                    name = "Shoulders",
                    controls = {
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[1]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[1]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[1]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[1]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[2]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[2]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[2]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[2]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[3]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[3]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[3]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[3]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[4]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[4]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[4]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[4]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[5]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[5]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[5]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[5]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[6]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[6]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[6]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[6]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[7]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[7]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[7]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[7]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[8]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[8]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[8]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[8]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[9]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[9]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[9]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[9]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[10]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[10]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[10]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[10]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[11]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[11]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[11]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_SHOULDERS][LootWindow.ARMOR_TRAITS[11]] = newValue
                            end,
                        },
                    },
                }, -- }}}
                -- {{{ Waist
                {
                    type = "submenu",
                    name = "Waist",
                    controls = {
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[1]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[1]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[1]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[1]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[2]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[2]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[2]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[2]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[3]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[3]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[3]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[3]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[4]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[4]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[4]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[4]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[5]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[5]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[5]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[5]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[6]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[6]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[6]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[6]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[7]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[7]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[7]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[7]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[8]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[8]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[8]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[8]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[9]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[9]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[9]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[9]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[10]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[10]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[10]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[10]] = newValue
                            end,
                        },
                        {
                            type = "checkbox",
                            name = LootWindow.ARMOR_TRAIT_NAMES[LootWindow.ARMOR_TRAITS[11]],
                            default = LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[11]],
                            getFunc = function() return LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[11]] end,
                            setFunc = function(newValue)
                                LootWindow.sv.armorTraits[EQUIP_TYPE_WAIST][LootWindow.ARMOR_TRAITS[11]] = newValue
                            end,
                        },
                    },
                }, -- }}}

            }
        }, -- }}}
    }

    local settingsOptionPanel = LAM:RegisterAddonPanel(LootWindow.name.."_LAM", settingsWindowData)

    LAM:RegisterOptionControls(LootWindow.name.."_LAM", settingsOptionsData)
end
-- }}}
